# Generated by Django 4.1.3 on 2022-11-13 22:37

import django.db.models.deletion
from django.db import migrations, models

import generator.models


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Template",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                ("name", models.CharField(max_length=255)),
                ("slug", models.SlugField(max_length=255, unique=True)),
                ("template", models.TextField()),
                (
                    "jsonschema",
                    models.JSONField(
                        default=dict,
                        help_text="Use https://json-editor.github.io/json-editor/ to generate your schema.",
                        validators=[generator.models.validate_jsonschema],
                    ),
                ),
            ],
        ),
        migrations.CreateModel(
            name="DefaultValue",
            fields=[
                (
                    "id",
                    models.BigAutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "values",
                    models.JSONField(
                        default=dict,
                        help_text="Values will be merged with this order of priority (descending): user provided values, template default values, default values with no template attached.",
                    ),
                ),
                (
                    "template",
                    models.OneToOneField(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.CASCADE,
                        to="generator.template",
                    ),
                ),
            ],
        ),
    ]
